import numpy
import math

k, n = input().split()
k = int(k)
n = int(n)

MOD = 1000000007

mtx = numpy.zeros((k, k), dtype='object') 
for i in range(k):
  for j in range(k):
    if math.gcd(i+1, j+1) == 1:
      mtx[i,j] = 1
    else:
      mtx[i,j] = 0

print(int(numpy.linalg.matrix_power(mtx, n+1)[0,0]) % MOD)
